

#define PORTOut PORTB
#define PORTIn PINB
#define PORTDirection DDRB

#define SCL 0x02
#define SDA 0x04

//entspricht 400 KHz bei 16 MHz Prozessortakt
#define SCLFreq 40 

//fr EEPROM mit Adresse 000
#define WRITE 0xA0
#define READ 0xA1
void WaitHalfCycle(void);
char GetAck(void);
void StartEEPROM(void);
void StopEEPROM(void);
int WriteByteEEPROM(unsigned char data);
unsigned char ReadByteEEPROM(void);
void WaitHalfCycle(void){
int x;

for(x=0;x<(SCLFreq/2);x++);
}

char GetAck(){
int status=1;
WaitHalfCycle();
PORTDirection &= ~SDA;
PORTOut &= ~SCL;
WaitHalfCycle();
PORTOut |= SCL;
if((PORTIn & SDA) == 0){
status=0;
}
PORTOut &=~ SCL;
WaitHalfCycle();
PORTDirection |= SDA;
return status;
} 
void StartEEPROM(void){
PORTOut |= SDA;
PORTOut |= SCL;
WaitHalfCycle();
PORTOut &= ~ SDA;
WaitHalfCycle();
}

void StopEEPROM(void){
int x;
PORTOut &= ~SDA;
PORTOut |= SCL;
WaitHalfCycle();
PORTOut |= SDA;
for(x=0;x<=250;x++){
WaitHalfCycle();}
}

int WriteByteEEPROM(unsigned char data){
int x;


for(x=0;x<=7;x++){
PORTOut &=~ SCL;
WaitHalfCycle();
switch(((data << x)& 0x80)){
 case 0x00:
  PORTOut &= ~SDA;
 break;
 case 0x80:
 PORTOut |= SDA;
 break;
 }
PORTOut |= SCL;
WaitHalfCycle();
}
return(GetAck());
}

unsigned char ReadByteEEPROM(){
int x;
unsigned char data=0x00;

for(x=0;x<=7;x++){
PORTOut &=~ SCL;
WaitHalfCycle();
PORTOut |= SCL;
WaitHalfCycle();

if((PORTIn & SDA) == 0x00){
data &= ~0x01;
}
else data |= 0x01;
if(x<7){
data=(data << 1) ;}
}
GetAck();
return(data);
}

int WriteEEPROM(unsigned char data, unsigned short addr){
int status=1;
PORTDirection |= SCL;
PORTDirection |= SDA;
StartEEPROM();
status  = WriteByteEEPROM(WRITE);
status += WriteByteEEPROM(0x1F & (addr>>8));
status += WriteByteEEPROM(0xFF & addr);
status += WriteByteEEPROM(data);
StopEEPROM();
if(status == 0){
return (0);
}
else return (1);
}

unsigned char ReadEEPROM(short addr){
int status =1;
unsigned char data;
PORTDirection |= SCL;
PORTDirection |= SDA;
StartEEPROM();
status  = WriteByteEEPROM(WRITE);
status += WriteByteEEPROM(0x1F & (addr>>8));
status += WriteByteEEPROM(0xFF & addr);
StartEEPROM();
status  += WriteByteEEPROM(READ);
PORTDirection &= ~SDA;
data = ReadByteEEPROM();
StopEEPROM();

return (data);

}
void EraseEEPROM(void){
short x;
for(x=0x0000;x<=0x1FFF;x++){
if(WriteEEPROM(0xFF,x)!=0){break;}
}
}